libzypp: zypp::sat::SolvableSet Class Reference

libzypp 17.38.11

zypp::sat::SolvableSet Class Reference

Solvable set wrapper to allow adding additional convenience iterators. More...

`#include <zypp/sat/SolvableSet.h>`

Inheritance diagram for zypp::sat::SolvableSet:

## Public Types
using | Container = std::unordered_set<Solvable>
using | value_type = Container::value_type
using | size_type = Container::size_type
using | const_iterator = Solvable_iterator
Public Types inherited from zypp::sat::SolvIterMixin< SolvableSet, std::unordered_set< Solvable >::const_iterator >
using | size_type
using | Solvable_iterator
using | PoolItem_iterator
using | Selectable_iterator

## Public Member Functions
| SolvableSet ()
| Default ctor.
template<class TInputIterator>
| SolvableSet (TInputIterator begin_r, TInputIterator end_r)
| Ctor building a set from a range.
bool | empty () const
| Whether the set is epmty.
size_type | size () const
| Size of the set.
template<class TSolv>
bool | contains (const TSolv &solv_r) const
const_iterator | begin () const
| Iterator pointing to the first Solvable.
const_iterator | end () const
| Iterator pointing behind the last Solvable.
void | clear ()
| Clear the container.
template<class TSolv>
bool | insert (const TSolv &solv_r)
| Insert a Solvable.
template<class TIterator>
void | insert (TIterator begin_r, TIterator end_r)
| Insert a range of Solvables.
Container & | get ()
| The set.
const Container & | get () const
| The set.
Public Member Functions inherited from zypp::sat::SolvIterMixin< SolvableSet, std::unordered_set< Solvable >::const_iterator >
bool | empty () const
| Whether the collection is epmty.
size_type | size () const
| Size of the collection.
bool | contains (const TSolv &solv_r) const
| Whether collection contains a specific Solvable.
Solvable_iterator | solvableBegin () const
Solvable_iterator | solvableEnd () const
Iterable< Solvable_iterator > | solvable () const
PoolItem_iterator | poolItemBegin () const
PoolItem_iterator | poolItemEnd () const
Iterable< PoolItem_iterator > | poolItem () const
Selectable_iterator | selectableBegin () const
Selectable_iterator | selectableEnd () const
Iterable< Selectable_iterator > | selectable () const

## Private Attributes
RWCOW_pointer< Container > | _pimpl
| Pointer to implementation.

## Friends
std::ostream & | operator<< (std::ostream &str, const SolvableSet &obj)
| relates: SolvableSet Stream output

## Additional Inherited Members
| SolvIterMixin ()
| ~SolvIterMixin ()
SolvIterMixin & | operator= (const SolvIterMixin &)=default

## Detailed Description

Solvable set wrapper to allow adding additional convenience iterators.

Definition at line 35 of file SolvableSet.h.

## Member Typedef Documentation

## ◆ Container

using zypp::sat::SolvableSet::Container = std::unordered_set<Solvable>

Definition at line 40 of file SolvableSet.h.

## ◆ value_type

using zypp::sat::SolvableSet::value_type = Container::value_type

Definition at line 41 of file SolvableSet.h.

## ◆ size_type

using zypp::sat::SolvableSet::size_type = Container::size_type

Definition at line 42 of file SolvableSet.h.

## ◆ const_iterator

using zypp::sat::SolvableSet::const_iterator = Solvable_iterator

Definition at line 43 of file SolvableSet.h.

## Constructor & Destructor Documentation

## ◆ SolvableSet() [1/2]

zypp::sat::SolvableSet::SolvableSet | ( |  | ) |
| inline

Default ctor.

Definition at line 47 of file SolvableSet.h.

## ◆ SolvableSet() [2/2]

template<class TInputIterator>

zypp::sat::SolvableSet::SolvableSet | ( | TInputIterator | begin_r,
|  | TInputIterator | end_r )
| inline

Ctor building a set from a range.

Definition at line 53 of file SolvableSet.h.

## Member Function Documentation

## ◆ empty()

bool zypp::sat::SolvableSet::empty | ( |  | ) | const
| inline

Whether the set is epmty.

Definition at line 59 of file SolvableSet.h.

## ◆ size()

size_type zypp::sat::SolvableSet::size | ( |  | ) | const
| inline

Size of the set.

Definition at line 63 of file SolvableSet.h.

## ◆ contains()

template<class TSolv>

bool zypp::sat::SolvableSet::contains | ( | const TSolv & | solv_r | ) | const
| inline

Definition at line 68 of file SolvableSet.h.

## ◆ begin()

const_iterator zypp::sat::SolvableSet::begin | ( |  | ) | const
| inline

Iterator pointing to the first Solvable.

Definition at line 72 of file SolvableSet.h.

## ◆ end()

const_iterator zypp::sat::SolvableSet::end | ( |  | ) | const
| inline

Iterator pointing behind the last Solvable.

Definition at line 76 of file SolvableSet.h.

## ◆ clear()

void zypp::sat::SolvableSet::clear | ( |  | ) |
| inline

Clear the container.

Definition at line 81 of file SolvableSet.h.

## ◆ insert() [1/2]

template<class TSolv>

bool zypp::sat::SolvableSet::insert | ( | const TSolv & | solv_r | ) |
| inline

Insert a Solvable.

Returns
  `true` if it was actually inserted, or `false` if already present.

Definition at line 88 of file SolvableSet.h.

## ◆ insert() [2/2]

template<class TIterator>

void zypp::sat::SolvableSet::insert | ( | TIterator | begin_r,
|  | TIterator | end_r )
| inline

Insert a range of Solvables.

Definition at line 93 of file SolvableSet.h.

## ◆ get() [1/2]

Container & zypp::sat::SolvableSet::get | ( |  | ) |
| inline

The set.

Definition at line 98 of file SolvableSet.h.

## ◆ get() [2/2]

const Container & zypp::sat::SolvableSet::get | ( |  | ) | const
| inline

The set.

Definition at line 102 of file SolvableSet.h.

## Friends And Related Symbol Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | str,
|  | const SolvableSet & | obj )
| friend

relates: SolvableSet Stream output

Definition at line 31 of file SolvableSet.cc.

## Member Data Documentation

## ◆ _pimpl

RWCOW_pointer<Container> zypp::sat::SolvableSet::_pimpl
| private

Pointer to implementation.

Definition at line 107 of file SolvableSet.h.

The documentation for this class was generated from the following file:

- zypp/sat/SolvableSet.h